#!/bin/sh -x


bin_update() {

	for FILE in $(find /tmp/update -name '*.bin' | sort); do
		echo "Run update file $FILE"
		/usr/sbin/os-update -u $FILE
	done
	
	/usr/sbin/os-reset
}

web_update() {

	if [ -r '/tmp/update/os-web.tar.gz' ]; then
		echo "Run web interface update"
		tar -C /tmp/update -xz -f /tmp/update/os-web.tar.gz
	    	#remove old files
	    	for file in $(find /home/os-web -type f | grep -v os-update.cgi); do
	       		rm -f $file
	    	done
	
	    	cd /tmp/update/os-web
	    	if [ -e cgi-bin/os-update.cgi ];then
	    		rm -f /home/os-web/cgi-bin/os-update.cgi
			mv -f cgi-bin/os-update.cgi /home/os-web/cgi-bin/
   	 	fi
	    	if [ -e boa.conf ]; then
	    		rm -f boa.conf
	   	fi
	
		cp -r * /home/os-web
	fi
}

scan_update() {


	if [ -r '/tmp/update/os-scan' ]; then
	
		test -x /etc/rc.d/init.d/os && /etc/rc.d/init.d/os stop
		test -x /etc/rc.d/init.d/osscan && /etc/rc.d/init.d/osscan stop
		
		install -m 755 /tmp/update/os-scan /usr/sbin
		install -m 755 /tmp/update/osscan /etc/rc.d/init.d
		
		if [ -x '/etc/rc.d/init.d/os' -a -x '/etc/rc.d/init.d/osscan' ]; then
			rm /etc/rc.d/init.d/os
		fi

	fi
}

update_update() {
	if [ -r '/tmp/update/os-update' ]; then
		install -m 755 /tmp/update/os-update /usr/sbin
	fi

	if [ -r '/tmp/update/update.sh' ]; then
		install -m 755 /tmp/update/update.sh /usr/sbin
	fi

	if [ ! -x '/usr/sbin/fw_printenv' ]; then
		install -m 755 /tmp/update/fw_printenv /usr/sbin
	fi

	if [ ! -x '/usr/sbin/fw_setenv' ]; then
		install -m 755 /tmp/update/fw_setenv /usr/sbin
	fi

}

reset_update() {
	if [ -r '/tmp/update/os-reset' ]; then
		install -m 755 /tmp/update/os-reset /usr/sbin
	fi
}

update_busybox()
{
#	ARP=`/bin/busybox | /bin/grep 'arping'`
#	ARPING=`/bin/busybox | /bin/grep 'arp'`
#	CROND=`/bin/busybox | /bin/grep 'crond'`

#	if [ -z $ARP -o -z $ARPING -o -z $CROND ]; then
		cp /bin/busybox /bin/busybox.old
		install -m 755 /tmp/update/busybox.new /tmp/install
		/tmp/install -m 755 /tmp/update/busybox.new /bin/busybox
#	fi

	MDEP=`find /lib/modules -name 'modules.dep'`

	echo -n "">/tmp/update/modules.dep

	for MOD in `find /lib/modules/ -type f -iname '*.ko'`; do
    		echo "$MOD:" >>/tmp/update/modules.dep
	done

	cmp -s $MDEP /tmp/update/modules.dep
	if [ $? -eq 1 ]; then
        	mv /lib/modules/2.6.25/modules.dep /lib/modules/2.6.25/modules.dep.bak
        	install -m 755 /tmp/update/modules.dep /lib/modules/2.6.25
	fi

	if [ ! -x '/sbin/arp' ]; then
		ln -s /bin/busybox /sbin/arp
		chmod 755 /sbin/arp
	fi

	if [ ! -x '/usr/bin/arping' ]; then
		ln -s /bin/busybox /usr/bin/arping
		chmod 755 /usr/bin/arping
	fi

	if [ ! -x '/usr/sbin/crond' ]; then
		ln -s /bin/busybox /usr/sbin/crond
		ln -s /bin/busybox /usr/bin/crontab
		chmod 755 /usr/sbin/crond
		chmod 755 /usr/bin/crontab
	fi

	if [ ! -x '/etc/crontabs/' ]; then
		/bin/mkdir -p /etc/crontabs
	fi
	
	cp /tmp/update/cron/root /etc/crontabs
	install -m 755 /tmp/update/cron/cron /etc/rc.d/init.d

	install -m 755 /tmp/update/garp /usr/bin/garp

}

update_discoverd() {
	
	install -m 755 /tmp/update/discoverd /usr/sbin
	install -m 755 /tmp/update/discoverd-init /etc/rc.d/init.d/discoverd
	
	install -m 755 /tmp/update/libdaemon.so.0.5.0 /usr/lib/
	ln -s /usr/lib/libdaemon.so.0.5.0 /usr/lib/libdaemon.so
	ln -s /usr/lib/libdaemon.so.0.5.0 /usr/lib/libdaemon.so.0
}

update_rc_conf() {
	cp /etc/rc.d/rc.conf /etc/rc.d/rc.conf.bak
	/usr/bin/tail -n7 /etc/rc.d/rc.conf >>/tmp/update/rc.conf
	cp /tmp/update/rc.conf /etc/rc.d/rc.conf
}

reset_update
update_update
bin_update
web_update
scan_update
update_busybox
update_discoverd
update_rc_conf

/usr/sbin/fw_setenv swid 2011.08

